/*
Local INdex maker "LIN" & "LIN-Win" (C) 1999-2013 Tatsuhiko Shoji
The sources for Local INdex maker "LIN" & "LIN-Win" are distributed under the MIT open source license
*/

#include <windows.h>

#ifdef __cplusplus
extern "C"{
#endif

/* fBNg̒ */
#define DIRBUF 260
#define ENABLE_SEARCH "EnableSearch"

struct bmList{
	WIN32_FIND_DATA f_info;	/* t@CɊւ̍\	*/
	unsigned char *name;		/* ^Cg					*/
	struct bmList *prev;		/* O̍\				*/
	struct bmList *next;		/* ЂƂ̍\				*/
};

/* IvVݒ֘A\ */
struct dir_config{
	struct bmList *top;			/* ACeXg擪 */
	struct bmList *current;		/* ACeXg[Np(\) */
	struct bmList *end;			/* ACeXgŌ */

	char title[256];			/* CfbNXt@C^Cg */
	int sorttype;				/* \[g */
	int HTMLtype;				/* CfbNXHTMLt@C` 0:m[} 1:\` 2:t[ */
	int subdir;					/* TufBNgtO 0:Ȃ 1: */
	int reverse;				/* \[g]tO */
	int dirlink;				/* TufBNg̃CfbNXt@CɃN邩H 0:NȂ 1:N */
	int ie5;					/* IE5̐fBNg0:Ȃ 1: */
	int Mozilla;				/* Mozilla̐fBNg0:Ȃ 1: */
	int hideDataDir;
	char out_fname;				// t@Co͂邩H
	char out_time;				// t@Co͂邩H
	char out_size;				// t@Co͂邩H
	char recSearch;				// ċAs?
	char absLink;				// pX΃Nɂ邩?
	char exclude;				// g̏o̓t@C܂ނۂ
	char otherLink;				/* ΏۊOt@Cւ̃N𒣂邩ۂH */
	char outfile[256];	/* o̓t@C */
	char name[256];	/* fBNg */
	char stylesheet[DIRBUF];	/* X^CV[g */
	char topStyle;				/* ʃfBNg̃X^CV[ggp邩H */
};

/* t@CXg֘A */
extern struct bmList *bm_top,*bm_end,*bm_base;
extern WIN32_FIND_DATA info_buf;

/* HTMLߊ֘A */
/* ^Cg͗p */
#define MAX_TITLE_LEN 1024	// ^Cg

/* o̓t@C` */
#define INDEX_TYPE_NORMAL 0	/* i` */
#define INDEX_TYPE_TABLE 1	/* e[u` */
#define INDEX_TYPE_FRAME 2	/* t[` */
#define INDEX_TYPE_WINDOW 3	/* _uEChE` */


/*  */
extern int titlelen;

/* IvVݒ(ftHg,R}hCIvV/GUIwl) */
extern char dir[DIRBUF];
extern char subdir;
extern char dispreverse;
extern char dirlink;
extern char ie5;
extern char Mozilla;
extern char hideDataDir;
extern char other;
extern char sorttype;
extern char HTMLtype;
extern char *outfile;
extern char *indextitle;
extern char *stylesheet;
extern char topStyle;

extern char out_fname;
extern char out_time;
extern char out_size;
extern char recSearch;
extern char absLink;
extern char exclude;

extern int volatile isStop;	// 1̏ꍇfꂽB

/* o[W */
extern char *progTitle;

/* t@Cʐݒۑp\ */
struct filetype {
	char name[16];
	int len;
	int type;
};

void titlecpy(int c);
void titlecat(char *s);
void inittitlebuf(void);
void terminatetitle(void);

void read_inifile(struct dir_config *,char *,char *);
int main2(unsigned char *,struct dir_config *,struct dir_config *);		//Gg|Cgēz

void ErrorMessage(char *mes);	// GUIłƃR\[łŕʁXɎ

/*----------------------------------*/
/* et@C̃nhOp֐Q */
/*----------------------------------*/
int CheckHTML(char *dir_name,char *filename);
int CheckNULL(char *dir_name,char *filename);
int CheckTXT(char *dir_name,char *filename);



#ifdef __cplusplus
}
#endif

